package com.sun.org.apache.xml.internal.security.c14n.implementations;

import org.w3c.dom.Comment;
import org.w3c.dom.ProcessingInstruction;
import org.xml.sax.SAXException;
import javax.xml.parsers.ParserConfigurationException;
import com.sun.org.apache.xml.internal.security.signature.XMLSignatureInput;
import java.io.IOException;
import org.w3c.dom.DOMException;
import java.util.Iterator;
import java.io.OutputStream;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Attr;
import java.util.TreeSet;
import java.util.Map;
import org.w3c.dom.Element;
import com.sun.org.apache.xml.internal.security.c14n.CanonicalizationException;
import org.w3c.dom.Node;
import java.util.Set;

public class CanonicalizerPhysical extends CanonicalizerBase
{
    public CanonicalizerPhysical() {
        super(true);
    }
    
    public byte[] engineCanonicalizeXPathNodeSet(Set<Node> set, String s) throws CanonicalizationException {
        throw new CanonicalizationException("c14n.Canonicalizer.UnsupportedOperation");
    }
    
    public byte[] engineCanonicalizeSubTree(Node node, String s) throws CanonicalizationException {
        throw new CanonicalizationException("c14n.Canonicalizer.UnsupportedOperation");
    }
    
    public byte[] engineCanonicalizeSubTree(Node node, String s, boolean b) throws CanonicalizationException {
        throw new CanonicalizationException("c14n.Canonicalizer.UnsupportedOperation");
    }
    
    protected void outputAttributesSubtree(Element element, NameSpaceSymbTable nameSpaceSymbTable, Map<String, byte[]> map) throws CanonicalizationException, DOMException, IOException {
        if (element.hasAttributes()) {
            TreeSet set = new TreeSet(CanonicalizerPhysical.COMPARE);
            NamedNodeMap attributes = element.getAttributes();
            for (int length = attributes.getLength(), i = 0; i < length; ++i) {
                set.add((Node)attributes.item(i));
            }
            OutputStream writer = this.getWriter();
            for (Attr attr : set) {
                CanonicalizerBase.outputAttrToWriter(attr.getNodeName(), attr.getNodeValue(), writer, map);
            }
        }
    }
    
    protected void outputAttributes(Element element, NameSpaceSymbTable nameSpaceSymbTable, Map<String, byte[]> map) throws CanonicalizationException, DOMException, IOException {
        throw new CanonicalizationException("c14n.Canonicalizer.UnsupportedOperation");
    }
    
    protected void circumventBugIfNeeded(XMLSignatureInput xmlSignatureInput) throws CanonicalizationException, ParserConfigurationException, IOException, SAXException {
    }
    
    @Override
    protected void handleParent(Element element, NameSpaceSymbTable nameSpaceSymbTable) {
    }
    
    @Override
    public final String engineGetURI() {
        return "http://santuario.apache.org/c14n/physical";
    }
    
    public final boolean engineGetIncludeComments() {
        return true;
    }
    
    @Override
    protected void outputPItoWriter(ProcessingInstruction processingInstruction, OutputStream outputStream, int n) throws IOException {
        super.outputPItoWriter(processingInstruction, outputStream, 0);
    }
    
    @Override
    protected void outputCommentToWriter(Comment comment, OutputStream outputStream, int n) throws IOException {
        super.outputCommentToWriter(comment, outputStream, 0);
    }
}
